$ontext
Time-stamp:     <2016-06-09 12:13:30 st>
First-written:  <2009/07/19>
$offtext
*       ----------------------------------------------------------------------
*       CO2 emissions:

*       CO2 emissions:
l_co2(ssol,en,j,r) = yaf.l(en,j,r) * co2f(en,j,r);
*       For CO2 emissions from CRP sec:
l_co2(ssol,en,crp,r) = yafc.l(en,crp,r) * co2f(en,crp,r);       
*       CO2 emissions from household:
l_co2(ssol,en,"hh",r) = yap.l(en,r) * co2h(en,r);

*       CO2 emissions by use:
l_co2_use(ssol,j,r) = sum(en, l_co2(ssol,en,j,r));
l_co2_use(ssol,"hh",r) = sum(en, l_co2(ssol,en,"hh",r));
l_co2_use(ssol,"eite",r) = sum(i$eite(i), l_co2_use(ssol,i,r));
l_co2_use(ssol,"trans",r) = sum(i$trans(i), l_co2_use(ssol,i,r));
l_co2_use(ssol,"neint",r) = sum(i$neint(i), l_co2_use(ssol,i,r));
l_co2_use(ssol,"svces",r) = sum(i$svces(i), l_co2_use(ssol,i,r));
l_co2_use(ssol,"fene",r) = sum(i$xe(i), l_co2_use(ssol,i,r));
l_co2_use(ssol,"sum",r) = sum(i, l_co2_use(ssol,i,r)) + l_co2_use(ssol,"hh",r);

*       CO2 emissions by sector:
l_co2_so(ssol,en,r) = sum(j, l_co2(ssol,en,j,r)) + l_co2(ssol,en,"hh",r);
l_co2_so(ssol,"sum",r) = sum(en, l_co2_so(ssol,en,r));

*       Total CO2 emissions:
l_co2_t(r,ssol) = sum((en,j), l_co2(ssol,en,j,r))
    + sum(en, l_co2(ssol,en,"hh",r));
l_co2_t("subj",ssol) = sum(r$subj(r), l_co2_t(r,ssol));
l_co2_t("nsubj",ssol) = sum(r$(not subj(r)), l_co2_t(r,ssol));
l_co2_t("sum",ssol) = sum(r, l_co2_t(r,ssol));

*       Parameter for calculating carbon leakage:
l_co2_leak_sec(ssol,i,"nsubj") = sum(r$(not subj(r)), l_co2_use(ssol,i,r));
l_co2_leak_sec(ssol,i,"subj") = sum(r$subj(r), l_co2_use(ssol,i,r));
l_co2_leak_sec(ssol,ssec,"nsubj") = sum(r$(not subj(r)), l_co2_use(ssol,ssec,r));
l_co2_leak_sec(ssol,ssec,"subj") = sum(r$subj(r), l_co2_use(ssol,ssec,r));

*       Parameter for calculating carbon leakage:
l_co2_leak(ssol,"nsubj") = sum(r$(not subj(r)), l_co2_t(r,ssol));
l_co2_leak(ssol,"subj") = sum(r$subj(r), l_co2_t(r,ssol));

*       Utility:
l_u(ssol,r) = u.l(r) * vu(r);
l_u(ssol,"subj") = sum(r$subj(r), l_u(ssol,r));
l_u(ssol,"nsubj") = sum(r$(not subj(r)), l_u(ssol,r));
l_u(ssol,"sum") = sum(r, l_u(ssol,r));
*       Consumption:
l_c(ssol,r) = zcon.l(r);
*       Leisure:
l_lsr(ssol,r) = 0 + zlsr.l(r)$(not fl_fixl);
*       Labor supply:
l_ls(ssol,r) = sum(i, zld.l(i,r));
*       Investment:
l_inv(ssol,r) = zinv.l(r);
*       Government expenditure:
l_gov(ssol,r) = zgov.l(r);

*       Export by commodity:
l_exp_c(ssol,i,r) = sum(s$vxmd(i,r,s), zexp.l(i,r,s)) + zvst.l(i,r);
l_exp_c(ssol,"sum",r) = sum(i, l_exp_c(ssol,i,r));
l_exp_c(ssol,"eite",r) = sum(i$eite(i), l_exp_c(ssol,i,r));
l_exp_c(ssol,"trans",r) = sum(i$trans(i), l_exp_c(ssol,i,r));
l_exp_c(ssol,"neint",r) = sum(i$neint(i), l_exp_c(ssol,i,r));
l_exp_c(ssol,"svces",r) = sum(i$svces(i), l_exp_c(ssol,i,r));
l_exp_c(ssol,"fene",r) = sum(i$xe(i), l_exp_c(ssol,i,r));
l_exp_c(ssol,"man",r) = sum(i$man(i), l_exp_c(ssol,i,r));

*       Import by commodity:
l_imp_c(ssol,i,r) = zimp.l(i,r);
l_imp_c(ssol,"sum",r) = sum(i, l_imp_c(ssol,i,r));
l_imp_c(ssol,"eite",r) = sum(i$eite(i), l_imp_c(ssol,i,r));
l_imp_c(ssol,"trans",r) = sum(i$trans(i), l_imp_c(ssol,i,r));
l_imp_c(ssol,"neint",r) = sum(i$neint(i), l_imp_c(ssol,i,r));
l_imp_c(ssol,"svces",r) = sum(i$svces(i), l_imp_c(ssol,i,r));
l_imp_c(ssol,"fene",r) = sum(i$xe(i), l_imp_c(ssol,i,r));
l_imp_c(ssol,"man",r) = sum(i$man(i), l_imp_c(ssol,i,r));

*       Net export by commodity:
l_nexp_c(ssol,i,r) = l_exp_c(ssol,i,r) - l_imp_c(ssol,i,r);
l_nexp_c(ssol,ssec,r) = l_exp_c(ssol,ssec,r) - l_imp_c(ssol,ssec,r);
l_nexp_c(ssol,"man",r) = l_exp_c(ssol,"man",r) - l_imp_c(ssol,"man",r);

*       Value of export:
l_ex_v(ssol,i,r,s)$r_s(r,s)
    = (1 + rtxs(i,r,s)) * py.l(i,r) * zexp.l(i,r,s);
l_ex_v(ssol,i,r,"trn") = py.l(i,r) * zvst.l(i,r);
l_ex_v(ssol,i,r,"sum") = sum(s$r_s(r,s), l_ex_v(ssol,i,r,s)) + l_ex_v(ssol,i,r,"trn");
l_ex_v(ssol,"sum",r,"sum")
    = sum((i,s)$r_s(r,s), l_ex_v(ssol,i,r,s)) + sum(i, l_ex_v(ssol,i,r,"trn"));
l_ex_v(ssol,"sum","sum","sum") = sum(r, l_ex_v(ssol,"sum",r,"sum"));

*       Value of import:
l_im_v(ssol,i,s,r)$r_s(r,s)
    = (1 + rtxs(i,s,r)) * py.l(i,s) * zexp.l(i,s,r)
    + sum(j, pt.l(j) * (vtwr(j,i,s,r) / vxmd(i,s,r)) * zexp.l(i,s,r));
l_im_v(ssol,i,"sum",r) = sum(s$r_s(r,s), l_im_v(ssol,i,s,r));
l_im_v(ssol,"sum","sum",r) = sum((i,s)$r_s(r,s), l_im_v(ssol,i,s,r));
l_im_v(ssol,"sum","sum","sum") = sum(r, l_im_v(ssol,"sum","sum",r));

*       Share of export:
l_ex_sh(ssol,i,r,s)$vxmd(i,r,s)
    = l_ex_v(ssol,i,r,s) / l_ex_v(ssol,"sum",r,"sum");
l_ex_sh(ssol,i,r,"trn")$vst(i,r)
    = l_ex_v(ssol,i,r,"trn") / l_ex_v(ssol,"sum",r,"sum");
l_ex_sh(ssol,"sum",r,"sum")
    = sum((i,s), l_ex_sh(ssol,i,r,s)) + sum(i, l_ex_sh(ssol,i,r,"trn"));

*       Share of import:
l_im_sh(ssol,i,s,r)$vxmd(i,s,r)
    = l_im_v(ssol,i,s,r) / l_im_v(ssol,"sum","sum",r);
l_im_sh(ssol,"sum","sum",r) = sum((i,s), l_im_sh(ssol,i,s,r));

*       Share of export in total output:
l_exp_sh(ssol,i,r)$vom(i,r) = (sum(s, zexp.l(i,r,s)) + zvst.l(i,r)) / zy.l(i,r);

*       Aggregate export and import:
l_exp(ssol,r) = sum(i, l_exp_c(ssol,i,r));
l_imp(ssol,r) = sum(i, l_imp_c(ssol,i,r));

l_exp_(ssol,r) =
    sum((i,s)$(vxmd(i,r,s) and r_s(r,s)), zexp.l(i,r,s)) + sum(i, zvst.l(i,r));
l_imp_(ssol,r) = sum((i,s)$(vxmd(i,s,r) and r_s(r,s)), zexp.l(i,s,r));

*       Real GDP (defined as C + I + G + EX - IM):
l_gdp(ssol,r) = l_c(ssol,r) + l_inv(ssol,r) + l_gov(ssol,r)
    + l_exp(ssol,r) - l_imp(ssol,r);
l_gdp(ssol,"subj") = sum(r$subj(r), l_gdp(ssol,r));
l_gdp(ssol,"nsubj") = sum(r$(not subj(r)), l_gdp(ssol,r));
l_gdp(ssol,"sum") = sum(r, l_gdp(ssol,r));

*       Permit price (deflated by CPI):
l_pco2(ssol,r) = (pco2.l(r)$pntr(r) + pco2w.l$ptr(r)) * 1000 / pc.l(r);

*       Output by sector:
l_y(ssol,i,r) = zy.l(i,r);
l_y(ssol,"sum",r) = sum(i, l_y(ssol,i,r));
l_y(ssol,"eite",r) = sum(i$eite(i), l_y(ssol,i,r));
l_y(ssol,"trans",r) = sum(i$trans(i), l_y(ssol,i,r));
l_y(ssol,"neint",r) = sum(i$neint(i), l_y(ssol,i,r));
l_y(ssol,"svces",r) = sum(i$svces(i), l_y(ssol,i,r));
l_y(ssol,"fene",r) = sum(i$xe(i), l_y(ssol,i,r));
l_y(ssol,"man",r) = sum(i$man(i), l_y(ssol,i,r));

*       Labor demand by sector:
l_ld(ssol,i,r) = zld.l(i,r);
l_ld(ssol,"sum",r) = sum(i, zld.l(i,r));
l_ld(ssol,"eite",r) = sum(i$eite(i), l_ld(ssol,i,r));
l_ld(ssol,"trans",r) = sum(i$trans(i), l_ld(ssol,i,r));
l_ld(ssol,"neint",r) = sum(i$neint(i), l_ld(ssol,i,r));
l_ld(ssol,"svces",r) = sum(i$svces(i), l_ld(ssol,i,r));
l_ld(ssol,"fene",r) = sum(i$xe(i), l_ld(ssol,i,r));

*       Capital demand by sector:
l_kd(ssol,i,r) = zkd.l(i,r);
l_kd(ssol,"sum",r) = sum(i, zkd.l(i,r));

*       Wage rate:
l_pl(ssol,r) = pl.l(r) / pc.l(r);
*       Wage rate for producer:
l_plp(ssol,r) = (1 + ltax.l(r)) * pl.l(r) / pc.l(r);
*       Rental price:
l_rk(ssol,r) = (rkr.l(r)$rsk + rkg.l$gk) / pc.l(r);
*       Output price (market price):
l_pym(ssol,i,r)$vom(i,r) = py.l(i,r) / pc.l(r);
*       Output price (agent price):
l_pya(ssol,i,r)$vom(i,r) = (1 - rto(i,r)) * py.l(i,r) / pc.l(r);

*       Labor tax rate:
l_labax(ssol,r) = ltax.l(r) + eps;

*       Value of permit revenue including value of gratis allocation:
l_vperm(ssol,r) = (pco2.l(r)$pntr(r) + pco2w.l$ptr(r)) * co2lim(r) / pc.l(r);

*       Value of emission permit purchased by household:
l_vpermhh(ssol,r) =
    (pco2.l(r)$pntr(r) + pco2w.l$ptr(r)) * sum(en, l_co2(ssol,en,"hh",r)) / pc.l(r);

*       Labor income:
l_labinc(ssol,r) = sum(i, zld.l(i,r)) * pl.l(r) / pc.l(r);

*       Household income
l_inc(ssol,r) = (hh.l(r) - (pl.l(r) * zlsr.l(r))$(not fl_fixl)) / pc.l(r);

*       Energy price (excl. permit payment):
l_pene_ex(ssol,i,r)$(subj(r) and e(i)) = py.l(i,r) / pc.l(r);

*       Value of labor tax:
l_vlabt(ssol,r) = sum(i, ltax.l(r) * pl.l(r) * zld.l(i,r)) / pc.l(r);

*       Value of lumpsum tax:
l_vlumpt(ssol,r) = pc.l(r) * vlump(r) / pc.l(r);

*       Import tax rates for BA:
l_bam(ssol,i,s,r)$fl_bam(i,s,r)
    = (tms.l(i,s,r) - rtms(i,s,r));
*       Average rate:
l_bam(ssol,i,"ave",r)$l_im_v(ssol,i,"sum",r)
    = sum(s, (l_im_v(ssol,i,s,r)/l_im_v(ssol,i,"sum",r)) * l_bam(ssol,i,s,r));

*       Export subsidy rates for BA:
l_bax(ssol,i,s,r)$fl_bax(i,s,r)
    = txs.l(i,s,r) - rtxs(i,s,r);
*       Average rate:   
l_bax(ssol,i,s,"ave")$l_ex_v(ssol,i,s,"sum")
    = sum(r, (l_ex_v(ssol,i,s,r)/l_ex_v(ssol,i,s,"sum")) * l_bax(ssol,i,s,r));

*       Import tax rates incl. BA tax:
l_rtms(ssol,i,s,r)$vxmd(i,s,r)
    = rtms(i,s,r)$(not fl_bam(i,s,r)) + tms.l(i,s,r)$fl_bam(i,s,r);

*       Export subsidy rates incl. BA subsidy :
l_rtxs(ssol,i,s,r)$vxmd(i,s,r)
    = rtxs(i,s,r)$(not fl_bax(i,s,r)) + txs.l(i,s,r)$fl_bax(i,s,r);

*       Value of other tax:
l_votht(ssol,r) = 
*       Output tax
    sum(j, rto(j,r) * py.l(j,r) * zy.l(j,r))
*       Sluggish factor tax:
    + sum(j, sum(sf, rtf(sf,j,r) * ps.l(sf,j,r) * zsy.l(sf,j,r)))
*       Capital tax:
    + sum(j, rtf("cap",j,r) * (rkr.l(r)$rsk + rkg.l$gk) * zkd.l(j,r))
*       Intermediate input tax:
    + sum(j, sum(i$vdfm(i,j,r), rtfd(i,j,r) * py.l(i,r) * zyafd.l(i,j,r)))
    + sum(j, sum(i$vifm(i,j,r), rtfi(i,j,r) * pm.l(i,r) * zyafi.l(i,j,r)))
*       Tax on consumption demand:
    + sum(i$vdpm(i,r), rtpd(i,r) * py.l(i,r) * zyapd.l(i,r))
    + sum(i$vipm(i,r), rtpi(i,r) * pm.l(i,r) * zyapi.l(i,r))
*       Tax on government demand:
    + sum(i$vdgm(i,r), rtgd(i,r) * py.l(i,r) * zyagd.l(i,r))
    + sum(i$vigm(i,r), rtgi(i,r) * pm.l(i,r) * zyagi.l(i,r))
*       Export subsidy
    + sum((i,s)$vxmd(i,r,s), l_rtxs(ssol,i,r,s) * py.l(i,r) * zexp.l(i,r,s))
*       Tariff
    + sum((i,s)$vxmd(i,s,r),
        l_rtms(ssol,i,s,r) * (1 + l_rtxs(ssol,i,s,r)) * py.l(i,s) * zexp.l(i,s,r))
    + sum((i,s,j)$(vtwr(j,i,s,r) and vxmd(i,s,r)),
        l_rtms(ssol,i,s,r) * pt.l(j) * vtwr(j,i,s,r) * zexp.l(i,s,r) / vxmd(i,s,r))
    ;
l_votht(ssol,r) = l_votht(ssol,r) / pc.l(r);

*       Value of total tax:
l_vtax(ssol,r) = l_vlabt(ssol,r) + l_vlumpt(ssol,r) + l_votht(ssol,r);

*       Value of government expenditure:
l_vgov(ssol,r) =
    l_vtax(ssol,r)
    + (pco2.l(r)$pntr(r) + pco2w.l$ptr(r)) * co2lim(r) / pc.l(r)
    - lump.l(r)$fl_lump(r)
    - govt.l(r) / pc.l(r);
;
*       Value of net permit revenue (excl. value of gratis allocation):
l_vpermn(ssol,r) = (pco2.l(r)$pntr(r) + pco2w.l$ptr(r)) * co2lim(r) / pc.l(r);

*       Share of electricity demand:
l_ely_sh(ssol,i,r) = zyafd.l("ely",i,r) / zy.l("ely",r);
l_ely_sh(ssol,"con",r) = zyapd.l("ely",r) / zy.l("ely",r);
l_ely_sh(ssol,"gov",r) = zyagd.l("ely",r) / zy.l("ely",r);
l_ely_sh(ssol,"exp",r) = (sum(s, zexp.l("ely",r,s)) + zvst.l("ely",r)) / zy.l("ely",r);
l_ely_sh(ssol,"sum",r) = sum(i, l_ely_sh(ssol,i,r)) + l_ely_sh(ssol,"exp",r)
    + l_ely_sh(ssol,"con",r) + l_ely_sh(ssol,"gov",r);

*       CO2 emissions from electricity:
l_co2_ely(ssol,i,r) = l_ely_sh(ssol,i,r) * l_co2_use(ssol,"ely",r);
l_co2_ely(ssol,"con",r) = l_ely_sh(ssol,"con",r) * l_co2_use(ssol,"ely",r);
l_co2_ely(ssol,"gov",r) = l_ely_sh(ssol,"gov",r) * l_co2_use(ssol,"ely",r);
l_co2_ely(ssol,"exp",r) = l_ely_sh(ssol,"exp",r) * l_co2_use(ssol,"ely",r);
l_co2_ely(ssol,"sum",r) = sum(i, l_co2_ely(ssol,i,r)) + l_co2_ely(ssol,"exp",r)
    + l_co2_ely(ssol,"con",r) + l_co2_ely(ssol,"gov",r);

*       Net trade tax revenue by BA:
*       Tariff
l_barev(ssol,"imp",r) =
    (sum((i,s)$vxmd(i,s,r),
        l_bam(ssol,i,s,r) * (1 + l_rtxs(ssol,i,s,r)) * py.l(i,s) * zexp.l(i,s,r))
        + sum((i,s,j)$(vtwr(j,i,s,r) and vxmd(i,s,r)),
            l_bam(ssol,i,s,r) * pt.l(j) * (vtwr(j,i,s,r)/vxmd(i,s,r)) * zexp.l(i,s,r))
    ) / pc.l(r);
;
*       Export subsidy
l_barev(ssol,"exp",r) =         
    sum((i,s)$vxmd(i,r,s), - l_bax(ssol,i,r,s) * py.l(i,r) * zexp.l(i,r,s)) / pc.l(r);
l_barev(ssol,"net",r) = l_barev(ssol,"imp",r) - l_barev(ssol,"exp",r);

l_exp_p(ssol,r) = 
    (sum((i,s), l_ex_sh(ssol,i,r,s) * (1 + l_rtxs(ssol,i,r,s)) * py.l(i,r))
        + sum(i, l_ex_sh(ssol,i,r,"trn") * py.l(i,r)))
    / pc.l(r);

l_imp_p(ssol,r) =
    (sum((i,s), l_im_sh(ssol,i,s,r) 
        * ((1 + l_rtxs(ssol,i,s,r)) * py.l(i,s)
            + sum(j$vxmd(i,s,r), pt.l(j) * (vtwr(j,i,s,r) / vxmd(i,s,r))))))
    / pc.l(r);

*       Terms of trade:
l_tot(ssol,r) =
    (sum((i,s), l_ex_sh(ssol,i,r,s) * (1 + l_rtxs(ssol,i,r,s)) * py.l(i,r))
        + sum(i, l_ex_sh(ssol,i,r,"trn") * py.l(i,r)))
    / (sum((i,s), l_im_sh(ssol,i,s,r) 
        * ((1 + l_rtxs(ssol,i,s,r)) * py.l(i,s)
            + sum(j$vxmd(i,s,r), pt.l(j) * (vtwr(j,i,s,r) / vxmd(i,s,r))))));

chk_l_co2_ba(ssol,i,r)$ncgd(i,r)
    = l_co2_use(ssol,i,r) - (co2t.l(i,r) - co2id.l(i,r));
chk_l_co2_ely(ssol,r,"id") = sum(i, co2id.l(i,r));
chk_l_co2_ely(ssol,r,"ely") = l_co2_use(ssol,"ely",r);

* --------------------
* Local Variables:
* mode: gams
* fill-column: 80
* coding: utf-8-dos
* End:
