$ontext
Time-stamp:     <2016-06-09 12:13:32 st>
First-written:  <2012/10/09>

$offtext

*       Level parameters:
parameter
    l_u         Utility
    l_lsr       Leisure
    l_c         Consumption
    l_inv       Investment
    l_gov       Government expenditures
    l_exp       Export
    l_imp       Import
    l_exp_p     Export price
    l_imp_p     Import price
    l_gdp       Real GDP
    l_exp_c     Export by commodity
    l_imp_c     Import by commodity
    l_nexp_c    Net export by commodity
    l_ls        Labor supply
    l_pco2      "Permit price ($/tCO2)"
    l_vgdp      Nominal GDP
    l_pgdp      GDP deflator
    l_y         Output
    l_va_s      VA by sector
    l_ld        Labor demand by sector
    l_kd        Capital demand by sector
    l_pl        Wage rate
    l_plp       Wage rate for producer
    l_rk        Rental price
    l_pym       Output price (market price)
    l_pya       Output price (producer price)
    l_labax     Labor tax rate (%)
    l_vperm     Value of emission permit
    l_vpermn    Value of net permit revenue
    l_vpermhh   Value of emission permit purchased by household
    l_labinc    Labor income
    l_inc       Household incom
    l_pene_ex   Energy price (excl. permit payment)
    l_pene_in   Energy price (incl. permit payment)
    l_barev     Net trade tax revenue by BA
    l_ex_v      Value of export
    l_im_v      Value of import
    l_ex_sh     Share of export
    l_im_sh     Share of import
    l_tot       Terms of trade
    l_bam       Import tax rates for BA
    l_bax       Export subsidy rates for BA
    l_rtms      "Import tax rates incl. BA tax"
    l_rtxs      "Export subsidy rates incl. BA subsidy"
    l_exp_      Export (excl. export to own regions)
    l_imp_      Import (excl. import from own regions)
;
parameter
    l_co2       CO2 emissions (MtCO2)
    l_co2_so    CO2 emissions by source (MtCO2)
    l_co2_use   CO2 emissions by use (MtCO2)
    l_co2_t     Total CO2 emissions (MtCO2)
    l_co2_ely   CO2 emissions from electricity
    l_co2_ce    CO2 coefficient (inc. indirect emissions)
    l_ely_sh    Share of electricity
    l_exp_sh    Share of export in total output

    l_co2_leak          Leakage
    l_co2_leak_sec      Leakage
    l_co2_leak_reg      Leakage
    l_leak_rate         Leakage rate (%)
    l_leak_rate_reg     Leakage rate by region (%)
;
parameter
    l_vlabt     Value of labor tax
    l_vlumpt    Value of lumpsum tax
    l_votht     Value of other tax
    l_vtax      Value of total tax
    l_vgov      Value of government expenditure
;
parameter
    d_co2_leak
    d_nexp_c            Change in net export by commodity
    d_co2_leak_sec      Carbon leakage by sector
    d_co2_leak_reg      Carbon leakage by region
    d_y                 Output
    d_co2_use           CO2 emissions by use (MtCO2)
;    
*       Parameters of % change:
parameter
    pc_u        Utility
    pc_lsr      Leisure
    pc_c        Consumption
    pc_inv      Investment
    pc_gov      Government expenditures
    pc_exp      Export
    pc_imp      Import
    pc_exp_p    Export price
    pc_imp_p    Import price
    pc_gdp      Real GDP
    pc_exp_c    Export by commodity
    pc_imp_c    Import by commodity
    pc_nexp_c   Net export by commodity
    pc_vgdp     Nominal GDP
    pc_pgdp     GDP deflator
    pc_ls       Labor supply
    pc_y        Output
    pc_va_s     VA by sector
    pc_ld       Labor demand by sector
    pc_kd       Capital demand by sector
    pc_pl       Wage rate
    pc_plp      Wage rate for producer
    pc_rk       Rental price
    pc_pym      Output price (market price)
    pc_pya      Output price (producer price)
    pc_labinc   Labor income
    pc_inc      Household incom
    pc_pene_ex  Energy price (excl. permit payment)
    pc_pene_in  Energy price (incl. permit payment)
    pc_tot      % change in terms of trade
    d_nexp_c_jpn        Net export by commodity in Japan
    pc_nexp_c_jpn       Net export by commodity in Japan
    pc_y_jpn            Output in Japan
    pc_ld_jpn           Labor demand by sector in Japan
    pc_co2_use_jpn      CO2 emissions by use in Japan
    pc_exp_     Export (excl. export to own regions)
    pc_imp_     Import (excl. import from own regions)
;
parameter
    pc_co2      CO2 emissions
    pc_co2_so   CO2 emissions by source
    pc_co2_use  CO2 emissions by use
    pc_co2_t    Total CO2 emissions
;
parameter
    r_summary           Report summary
    r_summary_jpn       Report summary for JPN
    r_summary_ba        Average BA tariff and export subsidy rates
    r_summary_ba_jpn    Average BA tariff and export subsidy rates in Japan
;
parameter
    chk_l_barev
    chk_l_co2_ba
    chk_l_co2_ely


* --------------------
* Local Variables:
* mode: gams
* coding: utf-8-dos
* fill-column: 80
* End:
